{
  "openapi": "3.0.0",
  "tags": [
    {
      "name": "Pipeline"
    },
    {
      "name": "PipelineRuns"
    },
    {
      "name": "Definitions"
    },
    {
      "name": "Environment properties"
    },
    {
      "name": "Triggers"
    },
    {
      "name": "Trigger properties"
    }
  ],
  "info": {
    "title": "CD Tekton Pipeline",
    "description": "## Introduction\n\nIBM Cloud® Continuous Delivery Tekton pipelines leverage the open source [Tekton Pipelines](https://tekton.dev/) project to provide continuous integration and continuous deployment capabilities within Kubernetes clusters.\n\n[Tekton Pipelines](https://tekton.dev/) is an open source project that you can use to configure and run continuous integration and continuous deployment pipelines within a Kubernetes cluster. Tekton pipelines are defined in `yaml` files, which are typically stored in a Git repository (repo).\n\nFor more information about our Continuous Delivery Tekton pipeline, see [Working with Tekton pipelines.](https://cloud.ibm.com/docs/ContinuousDelivery?topic=ContinuousDelivery-tekton-pipelines)\n\nInstalling the Node SDK.\n\n```sh\nnpm install @ibm-cloud/continuous-delivery\n```\n\nFor more information, view the project on GitHub: [https://github.com/IBM/continuous-delivery-node-sdk](https://github.com/IBM/continuous-delivery-node-sdk)\n\nInstalling the Python SDK.\n\n```bash\npip install \"ibm-continuous-delivery\"\n```\n\nFor more information, view the project on GitHub: [https://github.com/IBM/continuous-delivery-python-sdk](https://github.com/IBM/continuous-delivery-python-sdk)\n\nInstalling the Go SDK.\n\nGo modules (recommended): Add the following import in your code and then run `go mod tidy`.\n\n```go\nimport (\n  \"github.com/IBM/continuous-delivery-go-sdk/v2/cdtektonpipelinev2\"\n)\n```\n\nUsing Go get:\n\n```bash\ngo get -u github.com/IBM/continuous-delivery-go-sdk/v2/cdtektonpipelinev2\n```\n\nFor more information, view the project on GitHub: [https://github.com/IBM/continuous-delivery-go-sdk](https://github.com/IBM/continuous-delivery-go-sdk)\n\nInstalling the Java SDK.\n\nMaven example:\n```xml\n<dependency>\n    <groupId>com.ibm.cloud</groupId>\n    <artifactId>cd-tekton-pileline</artifactId>\n    <version>2.0.1</version>\n</dependency>\n```\n\nGradle example:\n```bash\ncompile 'com.ibm.cloud:cd-tekton-pileline:2.0.1'\n```\n\nFor more information, view the project on GitHub: https://github.com/IBM/continuous-delivery-java-sdk. See also [Using the SDK](https://github.com/IBM/ibm-cloud-sdk-common/blob/main/README.md#using-the-sdk).\n\n## Endpoint URL\n\n<!-- Single global endpoint -->\nThe Continuous Delivery Tekton pipeline API uses the regional endpoints. When you call the API, add the path for each method to form the complete API endpoint for your requests:\n\nContinuous Delivery will be discontinued in the following regions on 12 February 2027: **au-syd**, **ca-mon**, **ca-tor**, **us-east**. On 12 June 2026, customers will no longer be able to create new resources in the affected regions. However, if a region has no active usage, the region may be discontinued earlier and stop accepting new instances. [Learn more](https://cloud.ibm.com/docs/ContinuousDelivery?topic=ContinuousDelivery-faq_region_feature_consolidation).\n\n* Dallas: `https://api.us-south.devops.cloud.ibm.com/pipeline/v2`\n* London: `https://api.eu-gb.devops.cloud.ibm.com/pipeline/v2`\n* Frankfurt: `https://api.eu-de.devops.cloud.ibm.com/pipeline/v2`\n* Tokyo: `https://api.jp-tok.devops.cloud.ibm.com/pipeline/v2`\n* São Paulo: `https://api.br-sao.devops.cloud.ibm.com/pipeline/v2`\n* Montreal (**deprecated**, limited availability region): `https://api.ca-mon.devops.cloud.ibm.com/pipeline/v2`\n* Sydney (**deprecated**): `https://api.au-syd.devops.cloud.ibm.com/pipeline/v2`\n* Toronto (**deprecated**): `https://api.ca-tor.devops.cloud.ibm.com/pipeline/v2`\n* Washington DC (**deprecated**): `https://api.us-east.devops.cloud.ibm.com/pipeline/v2`\n\n**Note**: The following regions have been discontinued and are no longer available:\n* Osaka (jp-osa)\n* Madrid (eu-es)\n\n## Authentication\n\nAuthentication to the Tekton pipeline V2 API is enforced by using an IBM Cloud Identity and Access Management (IAM) access token. The token determines the actions that a user has access to when they use the API.\n\nTo get an access token, use an API key. To get your API key, access the [IBM Cloud API keys page](https://cloud.ibm.com/iam/apikeys) and create your API key. You can use this key to generate your IAM access (bearer) token. To use the Tekton API, add your valid IAM token to the HTTP Authorization request header, for example, `-H \"Authorization: Bearer <IAM_TOKEN_VALUE>\"`.\n\nExample request to generate an access token, where `<API_KEY>` is your [IBM Cloud API Key](https://cloud.ibm.com/iam/apikeys).:\n\n```bash\ncurl -X POST \\\n  'https://iam.cloud.ibm.com/identity/token' \\\n  -H 'Content-Type:application/x-www-form-urlencoded' \\\n  -H 'Accept:application/json' \\\n  -d 'grant_type=urn:ibm:params:oauth:grant-type:apikey&apikey=<API_KEY>'\n```\n\n From the result of this curl command, take the `access_token` value and use it in place of `<IAM_TOKEN_VALUE>` in the curl command below to authenticate into the Tekton API:\n\n```bash\ncurl -L --request GET \\\n  'https://api.us-south.devops.cloud.ibm.com/pipeline/v2/tekton_pipelines/<PIPELINE_ID>' \\\n  --header 'Authorization: Bearer <IAM_TOKEN_VALUE>'\n```\n\nOr export the returned `access_token` value as an environment variable and use that variable in the curl command:\n\n```bash\nexport IAMTOKEN=\"<access_token_value>\"\ncurl -L --request GET \\\n  'https://api.us-south.devops.cloud.ibm.com/pipeline/v2/tekton_pipelines/<PIPELINE_ID>' \\\n  --header 'Authorization: Bearer ${IAMTOKEN}'\n```\n\n**Setting client options through environment variables**\n\nExample environment variables, where `<API_KEY>` is an [IAM API key](https://cloud.ibm.com/iam/apikeys).\n\n```sh\nexport CD_TEKTON_PIPELINE_URL=https://api.us-south.devops.cloud.ibm.com/pipeline/v2\nexport CD_TEKTON_PIPELINE_AUTHTYPE=iam\nexport CD_TEKTON_PIPELINE_APIKEY=<API_KEY>\n```\n\nExample of constructing the service client\n\n```go\nimport {\n    \"github.com/IBM/continuous-delivery-go-sdk/v2/cdtektonpipelinev2\"\n}\n...\ncdTektonPipelineServiceOptions := &cdtektonpipelinev2.CdTektonPipelineV2Options{}\ncdTektonPipelineService, err = cdtektonpipelinev2.NewCdTektonPipelineV2UsingExternalConfig(cdTektonPipelineServiceOptions)\n```\n\n**Setting client options programmatically**\n\nConstruct the service client programmatically, where `<API_KEY>` is your hardcoded [IAM API key](https://cloud.ibm.com/iam/apikeys).\n\n```javascript\nconst CdTektonPipelineV2 = require('@ibm-cloud/continuous-delivery/cd-tekton-pipeline/v2');\nconst { IamAuthenticator } = require('@ibm-cloud/continuous-delivery/auth');\n\n// Create an IAM authenticator.\nconst authenticator = new IamAuthenticator({\n  apikey: '<API_KEY>'\n});\n\n// Construct the service client.\nconst tektonService = new CdTektonPipelineV2({\n  authenticator,                                                      // required\n  serviceUrl: 'https://api.us-south.devops.cloud.ibm.com/pipeline/v2' // optional\n});\n```\n\n**Setting client options through external configuration**\n\nExample environment variables, where `<API_KEY>` is an [IAM API key](https://cloud.ibm.com/iam/apikeys).\n\n```sh\nexport CD_TEKTON_PIPELINE_URL=https://api.us-south.devops.cloud.ibm.com/pipeline/v2\nexport CD_TEKTON_PIPELINE_AUTHTYPE=iam\nexport CD_TEKTON_PIPELINE_APIKEY=<API_KEY>\n```\n\nConstruct the service client using external configuration. `CdTektonPipelineV2.newInstance()` initializes the client with the environment variables, using them for subsequent authentication.\n\n```javascript\nconst CdTektonPipelineV2 = require('@ibm-cloud/continuous-delivery/cd-tekton-pipeline/v2');\nconst tektonService = CdTektonPipelineV2.newInstance();\n```\n\n**Setting client options through external configuration**\n\nExample environment variables, where `<API_KEY>` is an [IAM API key](https://cloud.ibm.com/iam/apikeys).\n\n```sh\nexport CD_TEKTON_PIPELINE_URL=https://api.us-south.devops.cloud.ibm.com/pipeline/v2\nexport CD_TEKTON_PIPELINE_AUTHTYPE=iam\nexport CD_TEKTON_PIPELINE_APIKEY=<API_KEY>\n```\n\nExample of constructing the service client\n\n```python\nfrom ibm_continuous_delivery.cd_tekton_pipeline_v2 import CdTektonPipelineV2\nservice = CdTektonPipelineV2.new_instance()\n```\n\n**Setting client options programmatically**\n\nConstruct the service client programmatically, where `<API_KEY>` is your hardcoded [IAM API key](https://cloud.ibm.com/iam/apikeys).\n\n```java\nimport com.ibm.cloud.continuous_delivery.cd_tekton_pipeline.v2.CdTektonPipeline;\nimport com.ibm.cloud.sdk.core.security.Authenticator;\nimport com.ibm.cloud.sdk.core.security.IamAuthenticator;\n...\nAuthenticator authenticator = new IamAuthenticator.Builder()\n  .apikey(\"<API_KEY>\")\n  .build();\nCdTektonPipeline pipelineSvc = new CdTektonPipeline(CdTektonPipeline.DEFAULT_SERVICE_NAME, authenticator);\n```\n\n## Error handling\n\nThis API uses standard HTTP response codes to indicate whether a method completed successfully. A `200` response indicates success. A `400` type response indicates a failure, and a `500` type response indicates an internal system error.\n\n| HTTP Error Code | Description           | Recovery                                                                    |\n|-----------------|-----------------------|-----------------------------------------------------------------------------|\n| `200`           | Success               | The request was successful.                                                 |\n| `400`           | Bad Request           | The input parameters in the request body are either incomplete or in the wrong format. Be sure to include all required parameters in your request. |\n| `401`           | Unauthorized          | You are not authorized to make this request. Log in to IBM Cloud and try again. If this error persists, contact the account owner to check your permissions. |\n| `404`           | Not Found             | The requested resource could not be found or The supplied authentication is not authorized to access '{namespace}'. |\n| `408`           | Request Timeout       | The connection to the server timed out. Wait a few minutes, then try again. |\n| `409`           | Conflict              | The entity is already in the requested state.                               |\n| `500`           | Internal Server Error | *offering_name* is currently unavailable. Your request could not be processed. Wait a few minutes and try again. |\n\n**ErrorResponse**\n\n| Name             | Type        | Description                                            |\n|----------------- | --------|--------------------------------------------------------|\n| `code` | Integer | HTTP error code.                                       |\n| `error` | String | Human-readable error string, like 'Invalid image file'.|\n\n## Versioning\n\nAll Tekton pipeline API requests are prefixed with a segment that represents the API version. The latest version of the Tekton pipeline API is `v2`. The versions of individual components of Continuous Delivery, such as `toolchain` and `pipeline`, may change independently of each other.\n\n## Pagination\n\nSome API requests may return multiple results. To avoid performance problems, these results are returned one page at a time, with a limited number of results in each page. `GET` requests for the `/tekton_pipelines/{pipeline_id}/pipeline_runs` resource use pagination.\n\nThe fields `first`, `previous`, `next`, and `last` are included in the collection response as needed, depending on the number of the results. The `href` property for these fields contains a URL reference to the appropriate page of results from the collection resource. Pagination is token based, where the response will return results from the beginning of the collection and will provide the appropriate `next` link, which contains a `start` token, to traverse through the rest of the collection.\n\nThe default page size is 50 items, and the maximum size is 100 items. To control the page size, use the `limit` query parameter.\n\n## Rate limiting\n\nRate limits for API requests are enforced on this service. If the number of requests reaches the request limit within the specified time window, no further requests are accepted until after the time window. Clients that are blocked by rate limited should wait and try the request again later.\n\nAn HTTP status code of 429 indicates that the rate limit has been exceeded.\n\n## Glossary\n\n* **Tekton Pipeline**: Continuous Delivery Tekton pipeline\n* **Pipeline run**: Continuous Delivery Tekton pipeline run\n* **PipelineRun**: Pure Tekton pipeline [PipelineRuns](https://github.com/tektoncd/pipeline/blob/main/docs/pipelineruns.md)\n\n## Related APIs\n\n* [Toolchain](https://cloud.ibm.com/apidocs/toolchain)",
    "version": "2.0.0",
    "x-codegen-config": {
      "go": {
        "apiPackage": "github.com/IBM/continuous-delivery-go-sdk/v2",
        "improvedNameFormatting": true
      },
      "java": {
        "apiPackage": "github.com/IBM/continuous-delivery-java-sdk",
        "improvedNameFormatting": true
      },
      "node": {
        "apiPackage": "github.com/IBM/continuous-delivery-node-sdk",
        "improvedNameFormatting": true
      },
      "python": {
        "apiPackage": "github.com/IBM/continuous-delivery-python-sdk",
        "improvedNameFormatting": true
      },
      "terraform": {
        "apiEndpoint": "IBMCLOUD_TEKTON_PIPELINE_ENDPOINT"
      }
    },
    "x-github": "https://github.ibm.com/cloud-api-docs/toolchain",
    "x-github-issues": "https://github.ibm.com/cloud-api-docs/toolchain/issues/new",
    "x-last-updated": "2026-04-30"
  },
  "servers": [
    {
      "url": "https://api.us-south.devops.cloud.ibm.com/pipeline/v2",
      "x-ibm-region": "us-south",
      "description": "The host URL for Tekton Pipeline Service in the us-south region."
    },
    {
      "url": "https://api.us-east.devops.cloud.ibm.com/pipeline/v2",
      "x-ibm-region": "us-east",
      "description": "The host URL for Tekton Pipeline Service in the us-east region."
    },
    {
      "url": "https://api.eu-de.devops.cloud.ibm.com/pipeline/v2",
      "x-ibm-region": "eu-de",
      "description": "The host URL for Tekton Pipeline Service in the eu-de region."
    },
    {
      "url": "https://api.eu-gb.devops.cloud.ibm.com/pipeline/v2",
      "x-ibm-region": "eu-gb",
      "description": "The host URL for Tekton Pipeline Service in the eu-gb region."
    },
    {
      "url": "https://api.jp-tok.devops.cloud.ibm.com/pipeline/v2",
      "x-ibm-region": "jp-tok",
      "description": "The host URL for Tekton Pipeline Service in the jp-tok region."
    },
    {
      "url": "https://api.au-syd.devops.cloud.ibm.com/pipeline/v2",
      "x-ibm-region": "au-syd",
      "description": "The host URL for Tekton Pipeline Service in the au-syd region."
    },
    {
      "url": "https://api.ca-tor.devops.cloud.ibm.com/pipeline/v2",
      "x-ibm-region": "ca-tor",
      "description": "The host URL for Tekton Pipeline Service in the ca-tor region."
    },
    {
      "url": "https://api.ca-mon.devops.cloud.ibm.com/pipeline/v2",
      "x-ibm-region": "ca-mon",
      "description": "Montreal (ca-mon) is a limited availability region and not generally available. The host URL for Tekton Pipeline Service in the ca-mon region."
    },
    {
      "url": "https://api.br-sao.devops.cloud.ibm.com/pipeline/v2",
      "x-ibm-region": "br-sao",
      "description": "The host URL for Tekton Pipeline Service in the br-sao region."
    }
  ],
  "paths": {
    "/tekton_pipelines": {
      "post": {
        "tags": [
          "Pipeline"
        ],
        "summary": "Create Tekton pipeline",
        "description": "This request creates a Tekton pipeline. Requires a pipeline tool already created in the toolchain using the toolchain API https://cloud.ibm.com/apidocs/toolchain#create-tool, and use the tool ID to create the Tekton pipeline",
        "operationId": "create_tekton_pipeline",
        "x-ibm-permissions": {
          "actions": [
            {
              "name": "toolchain.instance.update"
            }
          ]
        },
        "x-ibm-events": {
          "events": [
            {
              "name": "toolchain.pipeline.create"
            }
          ]
        },
        "requestBody": {
          "required": true,
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/TektonPipelinePrototype"
              },
              "examples": {
                "pipeline": {
                  "value": {
                    "id": "94619026-912b-4d92-8f51-6c74f0692d90",
                    "worker": {
                      "id": "public"
                    }
                  }
                }
              }
            }
          }
        },
        "responses": {
          "201": {
            "description": "Tekton pipeline data",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/TektonPipeline"
                },
                "example": {
                  "name": "ci-pipeline",
                  "runs_url": "https://cloud.ibm.com/devops/pipelines/tekton/94619026-912b-4d92-8f51-6c74f0692d90?env_id=ibm:ys1:us-south",
                  "resource_group": {
                    "id": "19c29990ffe42ce260f5a5cb64f54169"
                  },
                  "status": "configured",
                  "created_at": "2020-01-28T14:45:44.828Z",
                  "updated_at": "2021-11-18T01:16:00.724Z",
                  "toolchain": {
                    "id": "bf5fa00f-ddef-4298-b87b-aa8b6da0e1a6",
                    "crn": "crn:v1:staging:public:toolchain:us-south:a/0ba224679d6c697f9baee5e14ade83ac:bf5fa00f-ddef-4298-b87b-aa8b6da0e1a6::"
                  },
                  "properties": [],
                  "triggers": [],
                  "worker": {
                    "name": "IBM Managed workers (Tekton Pipelines v0.16.3) in DALLAS (Stage 1)",
                    "type": "public",
                    "id": "public"
                  },
                  "id": "94619026-912b-4d92-8f51-6c74f0692d90",
                  "enabled": true,
                  "definitions": [],
                  "build_number": 10,
                  "next_build_number": 11,
                  "enable_notifications": false,
                  "enable_partial_cloning": false,
                  "href": "https://api.us-south.devops.cloud.ibm.com/pipeline/v2/tekton_pipelines/94619026-912b-4d92-8f51-6c74f0692d90"
                }
              }
            }
          },
          "400": {
            "description": "Malformed request syntax or invalid request body",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorContainerModel"
                }
              }
            }
          },
          "401": {
            "description": "Authentication error or the IAM bearer token is missing",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorContainerModel"
                }
              }
            }
          },
          "404": {
            "description": "Pipeline not found or authorization failed",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorContainerModel"
                }
              }
            }
          },
          "429": {
            "$ref": "#/components/responses/RateLimit"
          }
        },
        "security": [
          {
            "iam_bearer_token": []
          }
        ],
        "x-sdk-operations": {
          "request-examples": {
            "curl": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "curl -X POST --location --header \"Authorization: Bearer ${iam_token}\" \\\n",
                      "  --header \"Accept: application/json\" \\\n",
                      "  --header \"Content-Type: application/json\" \\\n",
                      "  --data '{ \"id\": \"94619026-912b-4d92-8f51-6c74f0692d90\", \"worker\": { \"id\": \"public\" } }' \\\n",
                      "  \"https://api.us-south.devops.cloud.ibm.com/pipeline/v2/tekton_pipelines\""
                    ]
                  }
                ]
              }
            ],
            "go": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "workerIdentityModel := &cdtektonpipelinev2.WorkerIdentity{\n",
                      "  ID: core.StringPtr(\"public\"),\n",
                      "}\n",
                      "\n",
                      "createTektonPipelineOptions := cdTektonPipelineService.NewCreateTektonPipelineOptions(\n",
                      "  \"94619026-912b-4d92-8f51-6c74f0692d90\",\n",
                      ")\n",
                      "createTektonPipelineOptions.SetWorker(workerIdentityModel)\n",
                      "\n",
                      "tektonPipeline, response, err := cdTektonPipelineService.CreateTektonPipeline(createTektonPipelineOptions)\n",
                      "if err != nil {\n",
                      "  panic(err)\n",
                      "}\n",
                      "b, _ := json.MarshalIndent(tektonPipeline, \"\", \"  \")\n",
                      "fmt.Println(string(b))"
                    ]
                  }
                ]
              }
            ],
            "node": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "// Request models needed by this operation.\n",
                      "\n",
                      "// WorkerIdentity\n",
                      "const workerIdentityModel = {\n",
                      "  id: 'public',\n",
                      "};\n",
                      "\n",
                      "const params = {\n",
                      "  id: '94619026-912b-4d92-8f51-6c74f0692d90',\n",
                      "  worker: workerIdentityModel,\n",
                      "};\n",
                      "\n",
                      "let res;\n",
                      "try {\n",
                      "  res = await cdTektonPipelineService.createTektonPipeline(params);\n",
                      "  console.log(JSON.stringify(res.result, null, 2));\n",
                      "} catch (err) {\n",
                      "  console.warn(err);\n",
                      "}"
                    ]
                  }
                ]
              }
            ],
            "python": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "worker_identity_model = {\n",
                      "  'id': 'public',\n",
                      "}\n",
                      "\n",
                      "response = cd_tekton_pipeline_service.create_tekton_pipeline(\n",
                      "  id='94619026-912b-4d92-8f51-6c74f0692d90',\n",
                      "  worker=worker_identity_model,\n",
                      ")\n",
                      "tekton_pipeline = response.get_result()\n",
                      "\n",
                      "print(json.dumps(tekton_pipeline, indent=2))"
                    ]
                  }
                ]
              }
            ],
            "java": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "WorkerIdentity workerIdentityModel = new WorkerIdentity.Builder()\n",
                      "  .id(\"public\")\n",
                      "  .build();\n",
                      "CreateTektonPipelineOptions createTektonPipelineOptions = new CreateTektonPipelineOptions.Builder()\n",
                      "  .id(\"94619026-912b-4d92-8f51-6c74f0692d90\")\n",
                      "  .worker(workerIdentityModel)\n",
                      "  .build();\n",
                      "\n",
                      "Response<TektonPipeline> response = cdTektonPipelineService.createTektonPipeline(createTektonPipelineOptions).execute();\n",
                      "TektonPipeline tektonPipeline = response.getResult();\n",
                      "\n",
                      "System.out.println(tektonPipeline);"
                    ]
                  }
                ]
              }
            ]
          }
        }
      }
    },
    "/tekton_pipelines/{id}": {
      "parameters": [
        {
          "$ref": "#/components/parameters/id"
        }
      ],
      "get": {
        "tags": [
          "Pipeline"
        ],
        "summary": "Get Tekton pipeline data",
        "description": "This request retrieves the Tekton pipeline data for the pipeline identified by `{id}`",
        "operationId": "get_tekton_pipeline",
        "x-ibm-permissions": {
          "actions": [
            {
              "name": "toolchain.instance.retrieve"
            }
          ]
        },
        "x-ibm-events": {
          "events": [
            {
              "name": "toolchain.pipeline.read"
            }
          ]
        },
        "responses": {
          "200": {
            "description": "Tekton pipeline data",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/TektonPipeline"
                },
                "example": {
                  "name": "ci-pipeline",
                  "runs_url": "https://cloud.ibm.com/devops/pipelines/tekton/94619026-912b-4d92-8f51-6c74f0692d90?env_id=ibm:ys1:us-south",
                  "resource_group": {
                    "id": "19c29990ffe42ce260f5a5cb64f54169"
                  },
                  "status": "configured",
                  "created_at": "2020-01-28T14:45:44.828Z",
                  "updated_at": "2021-11-18T01:16:00.724Z",
                  "toolchain": {
                    "id": "bf5fa00f-ddef-4298-b87b-aa8b6da0e1a6",
                    "crn": "crn:v1:staging:public:toolchain:us-south:a/0ba224679d6c697f9baee5e14ade83ac:bf5fa00f-ddef-4298-b87b-aa8b6da0e1a6::"
                  },
                  "properties": [
                    {
                      "name": "pipeline-debug",
                      "value": "1",
                      "type": "text",
                      "href": "https://api.us-south.devops.cloud.ibm.com/pipeline/v2/tekton_pipelines/94619026-912b-4d92-8f51-6c74f0692d90/properties/pipeline-debug"
                    }
                  ],
                  "triggers": [
                    {
                      "id": "03b05e3d-cb46-44c9-8a4a-f12b76d7ae57",
                      "enabled": true,
                      "name": "manual-trigger",
                      "type": "manual",
                      "event_listener": "manual-listener",
                      "href": "https://api.us-south.devops.cloud.ibm.com/pipeline/v2/tekton_pipelines/94619026-912b-4d92-8f51-6c74f0692d90/triggers/03b05e3d-cb46-44c9-8a4a-f12b76d7ae57"
                    }
                  ],
                  "worker": {
                    "name": "IBM Managed workers (Tekton Pipelines v0.16.3) in DALLAS (Stage 1)",
                    "type": "public",
                    "id": "public"
                  },
                  "build_number": 1,
                  "next_build_number": 2,
                  "id": "94619026-912b-4d92-8f51-6c74f0692d90",
                  "enabled": true,
                  "enable_notifications": false,
                  "enable_partial_cloning": false,
                  "href": "https://api.us-south.devops.cloud.ibm.com/pipeline/v2/tekton_pipelines/94619026-912b-4d92-8f51-6c74f0692d90",
                  "definitions": [
                    {
                      "source": {
                        "type": "git",
                        "properties": {
                          "path": ".tekton",
                          "url": "https://github.com/open-toolchain/hello-tekton.git",
                          "branch": "master",
                          "tool": {
                            "id": "74895ba2-d6c9-4216-8a3e-eb883ae655d6"
                          }
                        }
                      },
                      "id": "22f92ab1-e0ac-4c65-84e7-8a4cb32dba0f",
                      "href": "https://api.us-south.devops.cloud.ibm.com/pipeline/v2/tekton_pipelines/94619026-912b-4d92-8f51-6c74f0692d90/definitions/22f92ab1-e0ac-4c65-84e7-8a4cb32dba0f"
                    }
                  ]
                }
              }
            }
          },
          "401": {
            "description": "Authentication error or the IAM bearer token is missing",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorContainerModel"
                }
              }
            }
          },
          "404": {
            "description": "Pipeline not found or authorization failed",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorContainerModel"
                }
              }
            }
          },
          "429": {
            "$ref": "#/components/responses/RateLimit"
          }
        },
        "security": [
          {
            "iam_bearer_token": []
          }
        ],
        "x-sdk-operations": {
          "request-examples": {
            "curl": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "curl -X GET --location --header \"Authorization: Bearer ${iam_token}\" \\\n",
                      "  --header \"Accept: application/json\" \\\n",
                      "  \"https://api.us-south.devops.cloud.ibm.com/pipeline/v2/tekton_pipelines/94619026-912b-4d92-8f51-6c74f0692d90\""
                    ]
                  }
                ]
              }
            ],
            "go": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "getTektonPipelineOptions := cdTektonPipelineService.NewGetTektonPipelineOptions(\n",
                      "  \"94619026-912b-4d92-8f51-6c74f0692d90\",\n",
                      ")\n",
                      "\n",
                      "tektonPipeline, response, err := cdTektonPipelineService.GetTektonPipeline(getTektonPipelineOptions)\n",
                      "if err != nil {\n",
                      "  panic(err)\n",
                      "}\n",
                      "b, _ := json.MarshalIndent(tektonPipeline, \"\", \"  \")\n",
                      "fmt.Println(string(b))"
                    ]
                  }
                ]
              }
            ],
            "node": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "const params = {\n",
                      "  id: '94619026-912b-4d92-8f51-6c74f0692d90',\n",
                      "};\n",
                      "\n",
                      "let res;\n",
                      "try {\n",
                      "  res = await cdTektonPipelineService.getTektonPipeline(params);\n",
                      "  console.log(JSON.stringify(res.result, null, 2));\n",
                      "} catch (err) {\n",
                      "  console.warn(err);\n",
                      "}"
                    ]
                  }
                ]
              }
            ],
            "python": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "response = cd_tekton_pipeline_service.get_tekton_pipeline(\n",
                      "  id='94619026-912b-4d92-8f51-6c74f0692d90',\n",
                      ")\n",
                      "tekton_pipeline = response.get_result()\n",
                      "\n",
                      "print(json.dumps(tekton_pipeline, indent=2))"
                    ]
                  }
                ]
              }
            ],
            "java": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "GetTektonPipelineOptions getTektonPipelineOptions = new GetTektonPipelineOptions.Builder()\n",
                      "  .id(\"94619026-912b-4d92-8f51-6c74f0692d90\")\n",
                      "  .build();\n",
                      "\n",
                      "Response<TektonPipeline> response = cdTektonPipelineService.getTektonPipeline(getTektonPipelineOptions).execute();\n",
                      "TektonPipeline tektonPipeline = response.getResult();\n",
                      "\n",
                      "System.out.println(tektonPipeline);"
                    ]
                  }
                ]
              }
            ]
          }
        }
      },
      "patch": {
        "tags": [
          "Pipeline"
        ],
        "summary": "Update Tekton pipeline data",
        "description": "This request updates Tekton pipeline data, such as the worker ID or build number, for example. Use other endpoints such as /definitions, /triggers, and /properties for other configuration updates",
        "operationId": "update_tekton_pipeline",
        "x-ibm-permissions": {
          "actions": [
            {
              "name": "toolchain.instance.update"
            }
          ]
        },
        "x-ibm-events": {
          "events": [
            {
              "name": "toolchain.pipeline.update"
            }
          ]
        },
        "x-codegen-request-body-name": "TektonPipelinePatch",
        "requestBody": {
          "content": {
            "application/merge-patch+json": {
              "schema": {
                "$ref": "#/components/schemas/TektonPipelinePatch"
              },
              "examples": {
                "pipeline": {
                  "value": {
                    "worker": {
                      "id": "public"
                    }
                  }
                }
              }
            }
          }
        },
        "responses": {
          "200": {
            "description": "Tekton pipeline data",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/TektonPipeline"
                },
                "example": {
                  "name": "ci-pipeline",
                  "runs_url": "https://cloud.ibm.com/devops/pipelines/tekton/94619026-912b-4d92-8f51-6c74f0692d90?env_id=ibm:ys1:us-south",
                  "resource_group": {
                    "id": "19c29990ffe42ce260f5a5cb64f54169"
                  },
                  "status": "configured",
                  "created_at": "2020-01-28T14:45:44.828Z",
                  "updated_at": "2021-11-18T01:16:00.724Z",
                  "toolchain": {
                    "id": "bf5fa00f-ddef-4298-b87b-aa8b6da0e1a6",
                    "crn": "crn:v1:staging:public:toolchain:us-south:a/0ba224679d6c697f9baee5e14ade83ac:bf5fa00f-ddef-4298-b87b-aa8b6da0e1a6::"
                  },
                  "properties": [
                    {
                      "name": "pipeline-debug",
                      "value": "1",
                      "type": "text",
                      "href": "https://api.us-south.devops.cloud.ibm.com/pipeline/v2/tekton_pipelines/94619026-912b-4d92-8f51-6c74f0692d90/properties/pipeline-debug"
                    }
                  ],
                  "triggers": [
                    {
                      "id": "03b05e3d-cb46-44c9-8a4a-f12b76d7ae57",
                      "enabled": true,
                      "name": "manual-trigger",
                      "type": "manual",
                      "event_listener": "manual-listener"
                    }
                  ],
                  "worker": {
                    "name": "IBM Managed workers (Tekton Pipelines v0.16.3) in DALLAS (Stage 1)",
                    "type": "public",
                    "id": "public"
                  },
                  "build_number": 1,
                  "next_build_number": 2,
                  "id": "94619026-912b-4d92-8f51-6c74f0692d90",
                  "enabled": true,
                  "enable_notifications": false,
                  "enable_partial_cloning": false,
                  "href": "https://api.us-south.devops.cloud.ibm.com/pipeline/v2/tekton_pipelines/94619026-912b-4d92-8f51-6c74f0692d90",
                  "definitions": [
                    {
                      "source": {
                        "type": "git",
                        "properties": {
                          "path": ".tekton",
                          "url": "https://github.com/open-toolchain/hello-tekton.git",
                          "branch": "master",
                          "tool": {
                            "id": "74895ba2-d6c9-4216-8a3e-eb883ae655d6"
                          }
                        }
                      },
                      "id": "22f92ab1-e0ac-4c65-84e7-8a4cb32dba0f",
                      "href": "https://api.us-south.devops.cloud.ibm.com/pipeline/v2/tekton_pipelines/94619026-912b-4d92-8f51-6c74f0692d90/definitions/22f92ab1-e0ac-4c65-84e7-8a4cb32dba0f"
                    }
                  ]
                }
              }
            }
          },
          "401": {
            "description": "Authentication error or the IAM bearer token is missing",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorContainerModel"
                }
              }
            }
          },
          "404": {
            "description": "Pipeline not found or authorization failed",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorContainerModel"
                }
              }
            }
          },
          "429": {
            "$ref": "#/components/responses/RateLimit"
          }
        },
        "security": [
          {
            "iam_bearer_token": []
          }
        ],
        "x-sdk-operations": {
          "request-examples": {
            "curl": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "curl -X PATCH --location --header \"Authorization: Bearer ${iam_token}\" \\\n",
                      "  --header \"Accept: application/json\" \\\n",
                      "  --header \"Content-Type: application/merge-patch+json\" \\\n",
                      "  --data '{\"worker\":{\"id\":\"public\"}}' \\\n",
                      "  \"https://api.us-south.devops.cloud.ibm.com/pipeline/v2/tekton_pipelines/94619026-912b-4d92-8f51-6c74f0692d90\""
                    ]
                  }
                ]
              }
            ],
            "go": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "workerIdentityModel := &cdtektonpipelinev2.WorkerIdentity{\n",
                      "  ID: core.StringPtr(\"public\"),\n",
                      "}\n",
                      "\n",
                      "tektonPipelinePatchModel := &cdtektonpipelinev2.TektonPipelinePatch{\n",
                      "  Worker: workerIdentityModel,\n",
                      "}\n",
                      "tektonPipelinePatchModelAsPatch, asPatchErr := tektonPipelinePatchModel.AsPatch()\n",
                      "Expect(asPatchErr).To(BeNil())\n",
                      "\n",
                      "updateTektonPipelineOptions := cdTektonPipelineService.NewUpdateTektonPipelineOptions(\n",
                      "  \"94619026-912b-4d92-8f51-6c74f0692d90\",\n",
                      ")\n",
                      "updateTektonPipelineOptions.SetTektonPipelinePatch(tektonPipelinePatchModelAsPatch)\n",
                      "\n",
                      "tektonPipeline, response, err := cdTektonPipelineService.UpdateTektonPipeline(updateTektonPipelineOptions)\n",
                      "if err != nil {\n",
                      "  panic(err)\n",
                      "}\n",
                      "b, _ := json.MarshalIndent(tektonPipeline, \"\", \"  \")\n",
                      "fmt.Println(string(b))"
                    ]
                  }
                ]
              }
            ],
            "node": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "// Request models needed by this operation.\n",
                      "\n",
                      "// WorkerIdentity\n",
                      "const workerIdentityModel = {\n",
                      "  id: 'public',\n",
                      "};\n",
                      "\n",
                      "const params = {\n",
                      "  id: '94619026-912b-4d92-8f51-6c74f0692d90',\n",
                      "  worker: workerIdentityModel,\n",
                      "};\n",
                      "\n",
                      "let res;\n",
                      "try {\n",
                      "  res = await cdTektonPipelineService.updateTektonPipeline(params);\n",
                      "  console.log(JSON.stringify(res.result, null, 2));\n",
                      "} catch (err) {\n",
                      "  console.warn(err);\n",
                      "}"
                    ]
                  }
                ]
              }
            ],
            "python": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "worker_identity_model = {\n",
                      "  'id': 'public',\n",
                      "}\n",
                      "\n",
                      "tekton_pipeline_patch_model = {\n",
                      "  'worker': worker_identity_model,\n",
                      "}\n",
                      "\n",
                      "response = cd_tekton_pipeline_service.update_tekton_pipeline(\n",
                      "  id='94619026-912b-4d92-8f51-6c74f0692d90',\n",
                      "  tekton_pipeline_patch=tekton_pipeline_patch_model,\n",
                      ")\n",
                      "tekton_pipeline = response.get_result()\n",
                      "\n",
                      "print(json.dumps(tekton_pipeline, indent=2))"
                    ]
                  }
                ]
              }
            ],
            "java": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "WorkerIdentity workerIdentityModel = new WorkerIdentity.Builder()\n",
                      "  .id(\"public\")\n",
                      "  .build();\n",
                      "TektonPipelinePatch tektonPipelinePatchModel = new TektonPipelinePatch.Builder()\n",
                      "  .worker(workerIdentityModel)\n",
                      "  .build();\n",
                      "Map<String, Object> tektonPipelinePatchModelAsPatch = tektonPipelinePatchModel.asPatch();\n",
                      "UpdateTektonPipelineOptions updateTektonPipelineOptions = new UpdateTektonPipelineOptions.Builder()\n",
                      "  .id(\"94619026-912b-4d92-8f51-6c74f0692d90\")\n",
                      "  .tektonPipelinePatch(tektonPipelinePatchModelAsPatch)\n",
                      "  .build();\n",
                      "\n",
                      "Response<TektonPipeline> response = cdTektonPipelineService.updateTektonPipeline(updateTektonPipelineOptions).execute();\n",
                      "TektonPipeline tektonPipeline = response.getResult();\n",
                      "\n",
                      "System.out.println(tektonPipeline);"
                    ]
                  }
                ]
              }
            ]
          }
        }
      },
      "delete": {
        "tags": [
          "Pipeline"
        ],
        "summary": "Delete a Tekton pipeline instance",
        "description": "This request deletes the Tekton pipeline instance that is associated with the pipeline toolchain integration",
        "operationId": "delete_tekton_pipeline",
        "x-ibm-permissions": {
          "actions": [
            {
              "name": "toolchain.instance.update"
            }
          ]
        },
        "x-ibm-events": {
          "events": [
            {
              "name": "toolchain.pipeline.delete"
            }
          ]
        },
        "responses": {
          "204": {
            "description": "Tekton pipeline instance deleted"
          },
          "401": {
            "description": "Authentication error or the IAM bearer token is missing",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorContainerModel"
                }
              }
            }
          },
          "404": {
            "description": "Pipeline not found or authorization failed",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorContainerModel"
                }
              }
            }
          },
          "429": {
            "$ref": "#/components/responses/RateLimit"
          }
        },
        "security": [
          {
            "iam_bearer_token": []
          }
        ],
        "x-sdk-operations": {
          "request-examples": {
            "curl": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "curl -X DELETE --location --header \"Authorization: Bearer ${iam_token}\" \\\n",
                      "  \"https://api.us-south.devops.cloud.ibm.com/pipeline/v2/tekton_pipelines/94619026-912b-4d92-8f51-6c74f0692d90\""
                    ]
                  }
                ]
              }
            ],
            "go": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "deleteTektonPipelineOptions := cdTektonPipelineService.NewDeleteTektonPipelineOptions(\n",
                      "  \"94619026-912b-4d92-8f51-6c74f0692d90\",\n",
                      ")\n",
                      "\n",
                      "response, err := cdTektonPipelineService.DeleteTektonPipeline(deleteTektonPipelineOptions)\n",
                      "if err != nil {\n",
                      "  panic(err)\n",
                      "}\n",
                      "if response.StatusCode != 204 {\n",
                      "  fmt.Printf(\"\\nUnexpected response status code received from DeleteTektonPipeline(): %d\\n\", response.StatusCode)\n",
                      "}"
                    ]
                  }
                ]
              }
            ],
            "node": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "const params = {\n",
                      "  id: '94619026-912b-4d92-8f51-6c74f0692d90',\n",
                      "};\n",
                      "\n",
                      "try {\n",
                      "  await cdTektonPipelineService.deleteTektonPipeline(params);\n",
                      "} catch (err) {\n",
                      "  console.warn(err);\n",
                      "}"
                    ]
                  }
                ]
              }
            ],
            "python": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "response = cd_tekton_pipeline_service.delete_tekton_pipeline(\n",
                      "  id='94619026-912b-4d92-8f51-6c74f0692d90',\n",
                      ")"
                    ]
                  }
                ]
              }
            ],
            "java": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "DeleteTektonPipelineOptions deleteTektonPipelineOptions = new DeleteTektonPipelineOptions.Builder()\n",
                      "  .id(\"94619026-912b-4d92-8f51-6c74f0692d90\")\n",
                      "  .build();\n",
                      "\n",
                      "Response<Void> response = cdTektonPipelineService.deleteTektonPipeline(deleteTektonPipelineOptions).execute();"
                    ]
                  }
                ]
              }
            ]
          }
        }
      }
    },
    "/tekton_pipelines/{pipeline_id}/pipeline_runs": {
      "parameters": [
        {
          "$ref": "#/components/parameters/pipelineId"
        }
      ],
      "get": {
        "tags": [
          "PipelineRuns"
        ],
        "summary": "List pipeline run records",
        "description": "This request lists pipeline run records, which have data about the runs, such as status, user_info, trigger and other information. Default limit is 50",
        "operationId": "list_tekton_pipeline_runs",
        "x-ibm-permissions": {
          "actions": [
            {
              "name": "toolchain.instance.retrieve"
            }
          ]
        },
        "x-ibm-events": {
          "events": [
            {
              "name": "toolchain.pipeline-run.read"
            }
          ]
        },
        "parameters": [
          {
            "name": "start",
            "in": "query",
            "description": "A page token that identifies the start point of the list of pipeline runs. This value is included in the response body of each request to fetch pipeline runs",
            "required": false,
            "schema": {
              "type": "string",
              "pattern": "^[0-9a-zA-Z_.+-\\/=]*$",
              "maxLength": 253,
              "minLength": 0
            }
          },
          {
            "name": "limit",
            "in": "query",
            "description": "The number of pipeline runs to return, sorted by creation time, most recent first",
            "required": false,
            "schema": {
              "format": "int32",
              "type": "integer",
              "default": 50,
              "maximum": 100,
              "minimum": 1
            }
          },
          {
            "name": "status",
            "in": "query",
            "description": "Filters the collection to resources with the specified status",
            "required": false,
            "schema": {
              "$ref": "#/components/schemas/RunStatus"
            }
          },
          {
            "name": "trigger.name",
            "in": "query",
            "description": "Filters the collection to resources with the specified trigger name",
            "required": false,
            "schema": {
              "$ref": "#/components/schemas/Query"
            },
            "example": "manual-trigger"
          }
        ],
        "responses": {
          "200": {
            "description": "List of pipeline runs",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/PipelineRunsCollection"
                },
                "example": {
                  "pipeline_runs": [
                    {
                      "id": "1681024e-4dfe-40dd-922b-b55719120078",
                      "worker": {
                        "id": "6f97df8f-5727-4a2b-bb71-541ba8e3f71f",
                        "agent_id": "a2fd3205-0d94-47e1-a867-444a6185db51"
                      },
                      "user_info": {
                        "iam_id": "IBMid-310001SNXX",
                        "sub": "firstname@domain.com"
                      },
                      "status": "succeeded",
                      "pipeline_id": "94619026-912b-4d92-8f51-6c74f0692d90",
                      "pipeline": {
                        "id": "94619026-912b-4d92-8f51-6c74f0692d90"
                      },
                      "event_params_blob": "{\"message\":\"hello world\",\"flag\":\"no-go\",\"properties\":[{\"name\":\"pipeline-debug\",\"value\":\"from-API\",\"type\":\"text\"},{\"name\":\"pipeline-debug-2\",\"value\":\"from-api-2\",\"type\":\"text\"}]}",
                      "definition_id": "ee41a181-afed-4308-bf2a-84d6c677a005",
                      "definition": {
                        "id": "ee41a181-afed-4308-bf2a-84d6c677a005"
                      },
                      "listener_name": "manual-listener",
                      "created_at": "2021-11-23T21:28:03.824Z",
                      "build_number": 1387,
                      "trigger": {
                        "id": "03b05e3d-cb46-44c9-8a4a-f12b76d7ae57",
                        "name": "manual-trigger",
                        "type": "manual",
                        "event_listener": "manual-listener",
                        "enabled": true,
                        "href": "https://api.us-south.devops.cloud.ibm.com/pipeline/v2/tekton_pipelines/94619026-912b-4d92-8f51-6c74f0692d90/triggers/03b05e3d-cb46-44c9-8a4a-f12b76d7ae57",
                        "properties": [
                          {
                            "name": "new",
                            "value": "123",
                            "type": "text",
                            "href": "https://api.us-south.devops.cloud.ibm.com/pipeline/v2/tekton_pipelines/94619026-912b-4d92-8f51-6c74f0692d90/triggers/03b05e3d-cb46-44c9-8a4a-f12b76d7ae57/properties/new"
                          }
                        ]
                      },
                      "href": "https://api.us-south.devops.cloud.ibm.com/pipeline/v2/tekton_pipelines/94619026-912b-4d92-8f51-6c74f0692d90/pipeline_runs/1681024e-4dfe-40dd-922b-b55719120078",
                      "run_url": "https://cloud.ibm.com/devops/pipelines/tekton/94619026-912b-4d92-8f51-6c74f0692d90/runs/1681024e-4dfe-40dd-922b-b55719120078?env_id=ibm:ys1:us-south"
                    }
                  ],
                  "limit": 10,
                  "first": {
                    "href": "https://api.us-south.devops.cloud.ibm.com/pipeline/v2/tekton_pipelines/94619026-912b-4d92-8f51-6c74f0692d90/pipeline_runs?limit=10"
                  },
                  "next": {
                    "href": "https://api.us-south.devops.cloud.ibm.com/pipeline/v2/tekton_pipelines/94619026-912b-4d92-8f51-6c74f0692d90/pipeline_runs?limit=10&start=MTY2MTkzNTY4MDMyMA=="
                  }
                }
              }
            }
          },
          "401": {
            "description": "Authentication error or the IAM bearer token is missing",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorContainerModel"
                }
              }
            }
          },
          "404": {
            "description": "Pipeline run not found or authorization failed",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorContainerModel"
                }
              }
            }
          },
          "429": {
            "$ref": "#/components/responses/RateLimit"
          }
        },
        "security": [
          {
            "iam_bearer_token": []
          }
        ],
        "x-sdk-operations": {
          "request-examples": {
            "curl": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "curl -X GET --location --header \"Authorization: Bearer ${iam_token}\" \\\n",
                      "  --header \"Accept: application/json\" \\\n",
                      "  \"https://api.us-south.devops.cloud.ibm.com/pipeline/v2/tekton_pipelines/94619026-912b-4d92-8f51-6c74f0692d90/pipeline_runs?status=succeeded&trigger.name=manual-trigger\""
                    ]
                  }
                ]
              }
            ],
            "go": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "listTektonPipelineRunsOptions := &cdtektonpipelinev2.ListTektonPipelineRunsOptions{\n",
                      "  PipelineID: core.StringPtr(\"94619026-912b-4d92-8f51-6c74f0692d90\"),\n",
                      "  Limit: core.Int64Ptr(int64(10)),\n",
                      "  Status: core.StringPtr(\"succeeded\"),\n",
                      "  TriggerName: core.StringPtr(\"manual-trigger\"),\n",
                      "}\n",
                      "\n",
                      "pager, err := cdTektonPipelineService.NewTektonPipelineRunsPager(listTektonPipelineRunsOptions)\n",
                      "if err != nil {\n",
                      "  panic(err)\n",
                      "}\n",
                      "\n",
                      "var allResults []cdtektonpipelinev2.PipelineRun\n",
                      "for pager.HasNext() {\n",
                      "  nextPage, err := pager.GetNext()\n",
                      "  if err != nil {\n",
                      "    panic(err)\n",
                      "  }\n",
                      "  allResults = append(allResults, nextPage...)\n",
                      "}\n",
                      "b, _ := json.MarshalIndent(allResults, \"\", \"  \")\n",
                      "fmt.Println(string(b))"
                    ]
                  }
                ]
              }
            ],
            "node": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "const params = {\n",
                      "  pipelineId: '94619026-912b-4d92-8f51-6c74f0692d90',\n",
                      "  limit: 10,\n",
                      "  status: 'succeeded',\n",
                      "  triggerName: 'manual-trigger',\n",
                      "};\n",
                      "\n",
                      "const allResults = [];\n",
                      "try {\n",
                      "  const pager = new CdTektonPipelineV2.TektonPipelineRunsPager(cdTektonPipelineService, params);\n",
                      "  while (pager.hasNext()) {\n",
                      "    const nextPage = await pager.getNext();\n",
                      "    expect(nextPage).not.toBeNull();\n",
                      "    allResults.push(...nextPage);\n",
                      "  }\n",
                      "  console.log(JSON.stringify(allResults, null, 2));\n",
                      "} catch (err) {\n",
                      "  console.warn(err);\n",
                      "}"
                    ]
                  }
                ]
              }
            ],
            "python": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "all_results = []\n",
                      "pager = TektonPipelineRunsPager(\n",
                      "  client=cd_tekton_pipeline_service,\n",
                      "  pipeline_id='94619026-912b-4d92-8f51-6c74f0692d90',\n",
                      "  limit=10,\n",
                      "  status='succeeded',\n",
                      "  trigger_name='manual-trigger',\n",
                      ")\n",
                      "while pager.has_next():\n",
                      "  next_page = pager.get_next()\n",
                      "  assert next_page is not None\n",
                      "  all_results.extend(next_page)\n",
                      "\n",
                      "print(json.dumps(all_results, indent=2))"
                    ]
                  }
                ]
              }
            ],
            "java": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "ListTektonPipelineRunsOptions listTektonPipelineRunsOptions = new ListTektonPipelineRunsOptions.Builder()\n",
                      "  .pipelineId(\"94619026-912b-4d92-8f51-6c74f0692d90\")\n",
                      "  .limit(Long.valueOf(\"10\"))\n",
                      "  .status(\"succeeded\")\n",
                      "  .triggerName(\"manual-trigger\")\n",
                      "  .build();\n",
                      "\n",
                      "TektonPipelineRunsPager pager = new TektonPipelineRunsPager(cdTektonPipelineService, listTektonPipelineRunsOptions);\n",
                      "List<PipelineRun> allResults = new ArrayList<>();\n",
                      "while (pager.hasNext()) {\n",
                      "  List<PipelineRun> nextPage = pager.getNext();\n",
                      "  allResults.addAll(nextPage);\n",
                      "}\n",
                      "\n",
                      "System.out.println(GsonSingleton.getGson().toJson(allResults));"
                    ]
                  }
                ]
              }
            ]
          }
        }
      },
      "post": {
        "tags": [
          "PipelineRuns"
        ],
        "summary": "Trigger a pipeline run",
        "description": "Trigger a new pipeline run using either the manual or the timed trigger, specifying the additional properties or overriding existing ones as needed",
        "operationId": "create_tekton_pipeline_run",
        "x-ibm-permissions": {
          "actions": [
            {
              "name": "toolchain.pipeline-run.create"
            }
          ]
        },
        "x-ibm-events": {
          "events": [
            {
              "name": "toolchain.pipeline-run.create"
            }
          ]
        },
        "requestBody": {
          "required": true,
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/PipelineRunPrototype"
              },
              "examples": {
                "trigger_example": {
                  "value": {
                    "description": "My custom manual PipelineRun",
                    "trigger": {
                      "name": "Manual Trigger 1",
                      "properties": {
                        "pipeline-debug": "false"
                      },
                      "secure_properties": {
                        "secure-property-key": "secure value"
                      },
                      "headers": {
                        "source": "api"
                      },
                      "body": {
                        "message": "hello world",
                        "enable": "true",
                        "detail": {
                          "name": "example"
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        "responses": {
          "201": {
            "description": "Pipeline run result and its status",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/PipelineRun"
                },
                "example": {
                  "pipeline_id": "94619026-912b-4d92-8f51-6c74f0692d90",
                  "pipeline": {
                    "id": "94619026-912b-4d92-8f51-6c74f0692d90"
                  },
                  "status": "pending",
                  "properties": [
                    {
                      "name": "pipeline-debug",
                      "value": "from-API",
                      "type": "text",
                      "href": "https://api.us-south.devops.cloud.ibm.com/pipeline/v2/tekton_pipelines/94619026-912b-4d92-8f51-6c74f0692d90/properties/pipeline-debug"
                    }
                  ],
                  "listener_name": "manual-listener",
                  "trigger": {
                    "name": "manual-trigger",
                    "event_listener": "manual-listener",
                    "type": "manual",
                    "id": "1bb892a1-2e04-4768-a369-b1159eace147",
                    "enabled": true
                  },
                  "type": "pipeline_run",
                  "description": "My custom manual PipelineRun",
                  "created_at": "2022-02-03T20:49:02.124Z",
                  "updated_at": "2022-02-03T20:49:02.124Z",
                  "id": "c4d6e785-f890-4ee4-92dd-f690f95b41a2",
                  "href": "https://api.us-south.devops.cloud.ibm.com/pipeline/v2/tekton_pipelines/94619026-912b-4d92-8f51-6c74f0692d90/pipeline_runs/c4d6e785-f890-4ee4-92dd-f690f95b41a2",
                  "run_url": "https://cloud.ibm.com/devops/pipelines/tekton/94619026-912b-4d92-8f51-6c74f0692d90/runs/c4d6e785-f890-4ee4-92dd-f690f95b41a2?env_id=ibm:ys1:us-south",
                  "worker": {
                    "id": "6f97df8f-5727-4a2b-bb71-541ba8e3f71f",
                    "name": "public"
                  },
                  "event_params_blob": "{\"message\":\"hello world\",\"flag\":\"no-go\",\"properties\":[{\"name\":\"pipeline-debug\",\"value\":\"from-API\",\"type\":\"text\"},{\"name\":\"pipeline-debug-2\",\"value\":\"from-api-2\",\"type\":\"text\"}]}",
                  "trigger_headers": "{\"x-forwarded-proto\":\"https\",\"user_iam_id\":\"IBMid-310001SNXX\",\"user_sub\":\"firstname@domain.com\",\"transaction-id\":\"3d20c668-856c-405b-93ee-157adb755111\",\"location\":\"my-post-man\",\"source\":\"post-man\",\"accept\":\"application/json\",\"x-request-id\":\"ba62177b-8e82-488f-9f41-68c43d7d1e21\",\"x-b3-traceid\":\"bd038d74d0ae28549e8915627ed817db\",\"x-b3-spanid\":\"e760ea7d4a6676d8\",\"x-b3-parentspanid\":\"9e8915627ed817db\",\"x-b3-sampled\":\"0\"}",
                  "definition_id": "ee41a181-afed-4308-bf2a-84d6c677a005",
                  "definition": {
                    "id": "ee41a181-afed-4308-bf2a-84d6c677a005"
                  }
                }
              }
            }
          },
          "400": {
            "description": "Malformed request syntax or invalid request body",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorContainerModel"
                }
              }
            }
          },
          "401": {
            "description": "Authentication error or the IAM bearer token is missing",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorContainerModel"
                }
              }
            }
          },
          "404": {
            "description": "Pipeline run not found or authorization failed",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorContainerModel"
                }
              }
            }
          },
          "429": {
            "$ref": "#/components/responses/RateLimit"
          }
        },
        "security": [
          {
            "iam_bearer_token": []
          }
        ],
        "x-sdk-operations": {
          "request-examples": {
            "curl": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "curl -X POST --location --header \"Authorization: Bearer ${iam_token}\" \\\n",
                      "  --header \"Accept: application/json\" \\\n",
                      "  --header \"Content-Type: application/json\" \\\n",
                      "  --data '{ \"description\": \"My custom manual PipelineRun\", \"trigger\": { \"name\": \"Manual Trigger 1\", \"properties\": { \"pipeline-debug\": \"false\" }, \"secure_properties\": { \"secure-property-key\": \"secure value\" }, \"headers\": { \"source\": \"api\" }, \"body\": { \"message\": \"hello world\", \"enable\": \"true\", \"detail\": { \"name\": \"example\" } } } }' \\\n",
                      "  \"https://api.us-south.devops.cloud.ibm.com/pipeline/v2/tekton_pipelines/94619026-912b-4d92-8f51-6c74f0692d90/pipeline_runs\""
                    ]
                  }
                ]
              }
            ],
            "go": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "pipelineRunTriggerModel := &cdtektonpipelinev2.PipelineRunTrigger{\n",
                      "  Name: core.StringPtr(\"Manual Trigger 1\"),\n",
                      "}\n",
                      "\n",
                      "createTektonPipelineRunOptions := cdTektonPipelineService.NewCreateTektonPipelineRunOptions(\n",
                      "  \"94619026-912b-4d92-8f51-6c74f0692d90\",\n",
                      ")\n",
                      "createTektonPipelineRunOptions.SetDescription(\"My custom manual PipelineRun\")\n",
                      "createTektonPipelineRunOptions.SetTrigger(pipelineRunTriggerModel)\n",
                      "\n",
                      "pipelineRun, response, err := cdTektonPipelineService.CreateTektonPipelineRun(createTektonPipelineRunOptions)\n",
                      "if err != nil {\n",
                      "  panic(err)\n",
                      "}\n",
                      "b, _ := json.MarshalIndent(pipelineRun, \"\", \"  \")\n",
                      "fmt.Println(string(b))"
                    ]
                  }
                ]
              }
            ],
            "node": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "// Request models needed by this operation.\n",
                      "\n",
                      "// PipelineRunTrigger\n",
                      "const pipelineRunTriggerModel = {\n",
                      "  name: 'Manual Trigger 1',\n",
                      "  properties: { 'pipeline-debug': 'false' },\n",
                      "  secure_properties: { 'secure-property-key': 'secure value' },\n",
                      "  headers: { source: 'api' },\n",
                      "  body: { message: 'hello world', enable: 'true', detail: { name: 'example' } },\n",
                      "};\n",
                      "\n",
                      "const params = {\n",
                      "  pipelineId: '94619026-912b-4d92-8f51-6c74f0692d90',\n",
                      "  description: 'My custom manual PipelineRun',\n",
                      "  trigger: pipelineRunTriggerModel,\n",
                      "};\n",
                      "\n",
                      "let res;\n",
                      "try {\n",
                      "  res = await cdTektonPipelineService.createTektonPipelineRun(params);\n",
                      "  console.log(JSON.stringify(res.result, null, 2));\n",
                      "} catch (err) {\n",
                      "  console.warn(err);\n",
                      "}"
                    ]
                  }
                ]
              }
            ],
            "python": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "pipeline_run_trigger_model = {\n",
                      "  'name': 'Manual Trigger 1',\n",
                      "  'properties': {'pipeline-debug': 'false'},\n",
                      "  'secure_properties': {'secure-property-key': 'secure value'},\n",
                      "  'headers': {'source': 'api'},\n",
                      "  'body': {'message': 'hello world', 'enable': 'true', 'detail': {'name': 'example'}},\n",
                      "}\n",
                      "\n",
                      "response = cd_tekton_pipeline_service.create_tekton_pipeline_run(\n",
                      "  pipeline_id='94619026-912b-4d92-8f51-6c74f0692d90',\n",
                      "  description='My custom manual PipelineRun',\n",
                      "  trigger=pipeline_run_trigger_model,\n",
                      ")\n",
                      "pipeline_run = response.get_result()\n",
                      "\n",
                      "print(json.dumps(pipeline_run, indent=2))"
                    ]
                  }
                ]
              }
            ],
            "java": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "PipelineRunTrigger pipelineRunTriggerModel = new PipelineRunTrigger.Builder()\n",
                      "  .name(\"Manual Trigger 1\")\n",
                      "  .build();\n",
                      "CreateTektonPipelineRunOptions createTektonPipelineRunOptions = new CreateTektonPipelineRunOptions.Builder()\n",
                      "  .pipelineId(\"94619026-912b-4d92-8f51-6c74f0692d90\")\n",
                      "  .description(\"My custom manual PipelineRun\")\n",
                      "  .trigger(pipelineRunTriggerModel)\n",
                      "  .build();\n",
                      "\n",
                      "Response<PipelineRun> response = cdTektonPipelineService.createTektonPipelineRun(createTektonPipelineRunOptions).execute();\n",
                      "PipelineRun pipelineRun = response.getResult();\n",
                      "\n",
                      "System.out.println(pipelineRun);"
                    ]
                  }
                ]
              }
            ]
          }
        }
      }
    },
    "/tekton_pipelines/{pipeline_id}/pipeline_runs/{id}": {
      "parameters": [
        {
          "$ref": "#/components/parameters/pipelineId"
        },
        {
          "$ref": "#/components/parameters/id"
        }
      ],
      "get": {
        "tags": [
          "PipelineRuns"
        ],
        "summary": "Get a pipeline run record",
        "description": "This request retrieves details of the pipeline run identified by `{id}`",
        "operationId": "get_tekton_pipeline_run",
        "x-ibm-permissions": {
          "actions": [
            {
              "name": "toolchain.instance.retrieve"
            }
          ]
        },
        "x-ibm-events": {
          "events": [
            {
              "name": "toolchain.pipeline-run.read"
            }
          ]
        },
        "parameters": [
          {
            "name": "includes",
            "in": "query",
            "description": "Defines if response includes definition metadata",
            "required": false,
            "style": "form",
            "explode": false,
            "example": "definitions",
            "schema": {
              "$ref": "#/components/schemas/RunIncludes"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "Pipeline run detail",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/PipelineRun"
                },
                "example": {
                  "id": "1681024e-4dfe-40dd-922b-b55719120078",
                  "worker": {
                    "id": "6f97df8f-5727-4a2b-bb71-541ba8e3f71f",
                    "agent_id": "a2fd3205-0d94-47e1-a867-444a6185db51",
                    "service_id": "ServiceId-43c88414-f9f7-44da-95b5-91bf55722025",
                    "name": "public"
                  },
                  "user_info": {
                    "iam_id": "IBMid-310001SNXX",
                    "sub": "firstname@domain.com"
                  },
                  "status": "succeeded",
                  "description": "My custom manual PipelineRun",
                  "pipeline_id": "94619026-912b-4d92-8f51-6c74f0692d90",
                  "pipeline": {
                    "id": "94619026-912b-4d92-8f51-6c74f0692d90"
                  },
                  "event_params_blob": "{\"message\":\"hello world\",\"flag\":\"no-go\",\"properties\":[{\"name\":\"pipeline-debug\",\"value\":\"from-API\",\"type\":\"text\"},{\"name\":\"pipeline-debug-2\",\"value\":\"from-api-2\",\"type\":\"text\"}]}",
                  "trigger_headers": "{\"x-forwarded-proto\":\"https\",\"user_iam_id\":\"IBMid-310001SNXX\",\"user_sub\":\"firstname@domain.com\",\"transaction-id\":\"95fd8923-fd75-4792-bfdd-07fd55d64fdc\",\"location\":\"my-post-man\",\"source\":\"post-man\",\"accept\":\"application/json\",\"x-request-id\":\"9292303b-92cd-48b2-9d80-e89cd0a19b3c\",\"x-b3-traceid\":\"8d423b020f5a9d30f2b505f644d9c1d5\",\"x-b3-spanid\":\"ee3d59e5925ce12f\",\"x-b3-parentspanid\":\"f2b505f644d9c1d5\",\"x-b3-sampled\":\"0\"}",
                  "definition_id": "ee41a181-afed-4308-bf2a-84d6c677a005",
                  "definition": {
                    "id": "ee41a181-afed-4308-bf2a-84d6c677a005"
                  },
                  "listener_name": "manual-listener",
                  "created_at": "2021-11-23T21:28:03.824Z",
                  "updated_at": "2022-01-28T19:05:45.764Z",
                  "build_number": 1387,
                  "trigger": {
                    "id": "03b05e3d-cb46-44c9-8a4a-f12b76d7ae57",
                    "name": "manual-trigger",
                    "enabled": true,
                    "href": "https://api.us-south.devops.cloud.ibm.com/pipeline/v2/tekton_pipelines/94619026-912b-4d92-8f51-6c74f0692d90/triggers/03b05e3d-cb46-44c9-8a4a-f12b76d7ae57",
                    "type": "manual",
                    "event_listener": "manual-listener",
                    "properties": [
                      {
                        "name": "new",
                        "value": "123",
                        "type": "text",
                        "href": "https://api.us-south.devops.cloud.ibm.com/pipeline/v2/tekton_pipelines/94619026-912b-4d92-8f51-6c74f0692d90/triggers/03b05e3d-cb46-44c9-8a4a-f12b76d7ae57/properties/new"
                      }
                    ]
                  },
                  "href": "https://api.us-south.devops.cloud.ibm.com/pipeline/v2/tekton_pipelines/94619026-912b-4d92-8f51-6c74f0692d90/pipeline_runs/1681024e-4dfe-40dd-922b-b55719120078",
                  "run_url": "https://cloud.ibm.com/devops/pipelines/tekton/94619026-912b-4d92-8f51-6c74f0692d90/runs/1681024e-4dfe-40dd-922b-b55719120078?env_id=ibm:ys1:us-south",
                  "definitions": [
                    {
                      "sha": "4162b1ebfd45538b5e258baf8cd51f3425149d03",
                      "repo_url": "https://github.com/open-toolchain/hello-tekton.git",
                      "id": "e92705ed-e0a0-4f3a-94ed-830df2c4f7fd",
                      "path": ".tekton",
                      "commit_url": "https://github.com/IBM/tekton-tutorial/commit/4162b1ebfd45538b5e258baf8cd51f3425149d03"
                    }
                  ]
                }
              }
            }
          },
          "401": {
            "description": "Authentication error or the IAM bearer token is missing",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorContainerModel"
                }
              }
            }
          },
          "404": {
            "description": "Pipeline run not found or authorization failed",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorContainerModel"
                }
              }
            }
          },
          "429": {
            "$ref": "#/components/responses/RateLimit"
          }
        },
        "security": [
          {
            "iam_bearer_token": []
          }
        ],
        "x-sdk-operations": {
          "request-examples": {
            "curl": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "curl -X GET --location --header \"Authorization: Bearer ${iam_token}\" \\\n",
                      "  --header \"Accept: application/json\" \\\n",
                      "  \"https://api.us-south.devops.cloud.ibm.com/pipeline/v2/tekton_pipelines/94619026-912b-4d92-8f51-6c74f0692d90/pipeline_runs/94619026-912b-4d92-8f51-6c74f0692d90?includes=definitions\""
                    ]
                  }
                ]
              }
            ],
            "go": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "getTektonPipelineRunOptions := cdTektonPipelineService.NewGetTektonPipelineRunOptions(\n",
                      "  \"94619026-912b-4d92-8f51-6c74f0692d90\",\n",
                      "  \"94619026-912b-4d92-8f51-6c74f0692d90\",\n",
                      ")\n",
                      "getTektonPipelineRunOptions.SetIncludes(\"definitions\")\n",
                      "\n",
                      "pipelineRun, response, err := cdTektonPipelineService.GetTektonPipelineRun(getTektonPipelineRunOptions)\n",
                      "if err != nil {\n",
                      "  panic(err)\n",
                      "}\n",
                      "b, _ := json.MarshalIndent(pipelineRun, \"\", \"  \")\n",
                      "fmt.Println(string(b))"
                    ]
                  }
                ]
              }
            ],
            "node": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "const params = {\n",
                      "  pipelineId: '94619026-912b-4d92-8f51-6c74f0692d90',\n",
                      "  id: '94619026-912b-4d92-8f51-6c74f0692d90',\n",
                      "  includes: 'definitions',\n",
                      "};\n",
                      "\n",
                      "let res;\n",
                      "try {\n",
                      "  res = await cdTektonPipelineService.getTektonPipelineRun(params);\n",
                      "  console.log(JSON.stringify(res.result, null, 2));\n",
                      "} catch (err) {\n",
                      "  console.warn(err);\n",
                      "}"
                    ]
                  }
                ]
              }
            ],
            "python": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "response = cd_tekton_pipeline_service.get_tekton_pipeline_run(\n",
                      "  pipeline_id='94619026-912b-4d92-8f51-6c74f0692d90',\n",
                      "  id='94619026-912b-4d92-8f51-6c74f0692d90',\n",
                      "  includes='definitions',\n",
                      ")\n",
                      "pipeline_run = response.get_result()\n",
                      "\n",
                      "print(json.dumps(pipeline_run, indent=2))"
                    ]
                  }
                ]
              }
            ],
            "java": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "GetTektonPipelineRunOptions getTektonPipelineRunOptions = new GetTektonPipelineRunOptions.Builder()\n",
                      "  .pipelineId(\"94619026-912b-4d92-8f51-6c74f0692d90\")\n",
                      "  .id(\"94619026-912b-4d92-8f51-6c74f0692d90\")\n",
                      "  .includes(\"definitions\")\n",
                      "  .build();\n",
                      "\n",
                      "Response<PipelineRun> response = cdTektonPipelineService.getTektonPipelineRun(getTektonPipelineRunOptions).execute();\n",
                      "PipelineRun pipelineRun = response.getResult();\n",
                      "\n",
                      "System.out.println(pipelineRun);"
                    ]
                  }
                ]
              }
            ]
          }
        }
      },
      "delete": {
        "tags": [
          "PipelineRuns"
        ],
        "summary": "Delete a pipeline run record",
        "description": "This request deletes the pipeline run record identified by `{id}`",
        "operationId": "delete_tekton_pipeline_run",
        "x-ibm-permissions": {
          "actions": [
            {
              "name": "toolchain.instance.update"
            }
          ]
        },
        "x-ibm-events": {
          "events": [
            {
              "name": "toolchain.pipeline-run.delete"
            }
          ]
        },
        "responses": {
          "204": {
            "description": "Pipeline run deleted"
          },
          "401": {
            "description": "Authentication error or the IAM bearer token is missing",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorContainerModel"
                }
              }
            }
          },
          "404": {
            "description": "Pipeline run not found or authorization failed",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorContainerModel"
                }
              }
            }
          },
          "429": {
            "$ref": "#/components/responses/RateLimit"
          }
        },
        "security": [
          {
            "iam_bearer_token": []
          }
        ],
        "x-sdk-operations": {
          "request-examples": {
            "curl": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "curl -X DELETE --location --header \"Authorization: Bearer ${iam_token}\" \\\n",
                      "  \"https://api.us-south.devops.cloud.ibm.com/pipeline/v2/tekton_pipelines/94619026-912b-4d92-8f51-6c74f0692d90/pipeline_runs/94619026-912b-4d92-8f51-6c74f0692d90\""
                    ]
                  }
                ]
              }
            ],
            "go": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "deleteTektonPipelineRunOptions := cdTektonPipelineService.NewDeleteTektonPipelineRunOptions(\n",
                      "  \"94619026-912b-4d92-8f51-6c74f0692d90\",\n",
                      "  \"94619026-912b-4d92-8f51-6c74f0692d90\",\n",
                      ")\n",
                      "\n",
                      "response, err := cdTektonPipelineService.DeleteTektonPipelineRun(deleteTektonPipelineRunOptions)\n",
                      "if err != nil {\n",
                      "  panic(err)\n",
                      "}\n",
                      "if response.StatusCode != 204 {\n",
                      "  fmt.Printf(\"\\nUnexpected response status code received from DeleteTektonPipelineRun(): %d\\n\", response.StatusCode)\n",
                      "}"
                    ]
                  }
                ]
              }
            ],
            "node": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "const params = {\n",
                      "  pipelineId: '94619026-912b-4d92-8f51-6c74f0692d90',\n",
                      "  id: '94619026-912b-4d92-8f51-6c74f0692d90',\n",
                      "};\n",
                      "\n",
                      "try {\n",
                      "  await cdTektonPipelineService.deleteTektonPipelineRun(params);\n",
                      "} catch (err) {\n",
                      "  console.warn(err);\n",
                      "}"
                    ]
                  }
                ]
              }
            ],
            "python": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "response = cd_tekton_pipeline_service.delete_tekton_pipeline_run(\n",
                      "  pipeline_id='94619026-912b-4d92-8f51-6c74f0692d90',\n",
                      "  id='94619026-912b-4d92-8f51-6c74f0692d90',\n",
                      ")"
                    ]
                  }
                ]
              }
            ],
            "java": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "DeleteTektonPipelineRunOptions deleteTektonPipelineRunOptions = new DeleteTektonPipelineRunOptions.Builder()\n",
                      "  .pipelineId(\"94619026-912b-4d92-8f51-6c74f0692d90\")\n",
                      "  .id(\"94619026-912b-4d92-8f51-6c74f0692d90\")\n",
                      "  .build();\n",
                      "\n",
                      "Response<Void> response = cdTektonPipelineService.deleteTektonPipelineRun(deleteTektonPipelineRunOptions).execute();"
                    ]
                  }
                ]
              }
            ]
          }
        }
      }
    },
    "/tekton_pipelines/{pipeline_id}/pipeline_runs/{id}/cancel": {
      "post": {
        "tags": [
          "PipelineRuns"
        ],
        "summary": "Cancel a pipeline run",
        "description": "This request cancels a running pipeline run identified by `{id}`. Use `force: true` in the body if the pipeline run can't be cancelled normally",
        "operationId": "cancel_tekton_pipeline_run",
        "x-ibm-permissions": {
          "actions": [
            {
              "name": "toolchain.instance.update"
            }
          ]
        },
        "x-ibm-events": {
          "events": [
            {
              "name": "toolchain.pipeline-run.update"
            }
          ]
        },
        "parameters": [
          {
            "$ref": "#/components/parameters/pipelineId"
          },
          {
            "$ref": "#/components/parameters/id"
          }
        ],
        "requestBody": {
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/CancelBody"
              },
              "examples": {
                "force_cancel": {
                  "value": {
                    "force": true
                  }
                }
              }
            }
          }
        },
        "responses": {
          "202": {
            "description": "Pipeline run detail",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/PipelineRun"
                },
                "example": {
                  "id": "1681024e-4dfe-40dd-922b-b55719120078",
                  "worker": {
                    "id": "6f97df8f-5727-4a2b-bb71-541ba8e3f71f",
                    "agent_id": "a2fd3205-0d94-47e1-a867-444a6185db51",
                    "service_id": "ServiceId-43c88414-f9f7-44da-95b5-91bf55722025",
                    "name": "public"
                  },
                  "user_info": {
                    "iam_id": "IBMid-310001SNXX",
                    "sub": "firstname@domain.com"
                  },
                  "status": "cancelled",
                  "pipeline_id": "94619026-912b-4d92-8f51-6c74f0692d90",
                  "pipeline": {
                    "id": "94619026-912b-4d92-8f51-6c74f0692d90"
                  },
                  "event_params_blob": "{\"message\":\"hello world\",\"flag\":\"no-go\",\"properties\":[{\"name\":\"pipeline-debug\",\"value\":\"from-API\",\"type\":\"text\"},{\"name\":\"pipeline-debug-2\",\"value\":\"from-api-2\",\"type\":\"text\"}]}",
                  "trigger_headers": "{\"x-forwarded-proto\":\"https\",\"user_iam_id\":\"IBMid-310001SNXX\",\"user_sub\":\"firstname@domain.com\",\"transaction-id\":\"95fd8923-fd75-4792-bfdd-07fd55d64fdc\",\"location\":\"my-post-man\",\"source\":\"post-man\",\"accept\":\"application/json\",\"x-request-id\":\"9292303b-92cd-48b2-9d80-e89cd0a19b3c\",\"x-b3-traceid\":\"8d423b020f5a9d30f2b505f644d9c1d5\",\"x-b3-spanid\":\"ee3d59e5925ce12f\",\"x-b3-parentspanid\":\"f2b505f644d9c1d5\",\"x-b3-sampled\":\"0\"}",
                  "definition_id": "ee41a181-afed-4308-bf2a-84d6c677a005",
                  "definition": {
                    "id": "ee41a181-afed-4308-bf2a-84d6c677a005"
                  },
                  "listener_name": "manual-listener",
                  "description": "My custom manual PipelineRun",
                  "created_at": "2021-11-23T21:28:03.824Z",
                  "updated_at": "2022-01-28T19:05:45.764Z",
                  "build_number": 1388,
                  "trigger": {
                    "id": "03b05e3d-cb46-44c9-8a4a-f12b76d7ae57",
                    "name": "manual-trigger",
                    "type": "manual",
                    "enabled": true,
                    "href": "https://api.us-south.devops.cloud.ibm.com/pipeline/v2/tekton_pipelines/94619026-912b-4d92-8f51-6c74f0692d90/triggers/03b05e3d-cb46-44c9-8a4a-f12b76d7ae57",
                    "event_listener": "manual-listener",
                    "properties": [
                      {
                        "name": "new",
                        "value": "123",
                        "type": "text",
                        "href": "https://api.us-south.devops.cloud.ibm.com/pipeline/v2/tekton_pipelines/94619026-912b-4d92-8f51-6c74f0692d90/triggers/03b05e3d-cb46-44c9-8a4a-f12b76d7ae57/properties/new"
                      }
                    ]
                  },
                  "href": "https://api.us-south.devops.cloud.ibm.com/pipeline/v2/tekton_pipelines/94619026-912b-4d92-8f51-6c74f0692d90/pipeline_runs/1681024e-4dfe-40dd-922b-b55719120078",
                  "run_url": "https://cloud.ibm.com/devops/pipelines/tekton/94619026-912b-4d92-8f51-6c74f0692d90/runs/1681024e-4dfe-40dd-922b-b55719120078?env_id=ibm:ys1:us-south",
                  "definitions": [
                    {
                      "sha": "4162b1ebfd45538b5e258baf8cd51f3425149d03",
                      "repo_url": "https://github.com/open-toolchain/hello-tekton.git",
                      "id": "e92705ed-e0a0-4f3a-94ed-830df2c4f7fd",
                      "path": ".tekton",
                      "commit_url": "https://github.com/IBM/tekton-tutorial/commit/4162b1ebfd45538b5e258baf8cd51f3425149d03"
                    }
                  ]
                }
              }
            }
          },
          "400": {
            "description": "Malformed request syntax or invalid request body",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorContainerModel"
                }
              }
            }
          },
          "401": {
            "description": "Authentication error or the IAM bearer token is missing",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorContainerModel"
                }
              }
            }
          },
          "404": {
            "description": "Pipeline run not found or authorization failed",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ErrorContainerModel"
                }
              }
            }
          },
          "429": {
            "$ref": "#/components/responses/RateLimit"
          }
        },
        "security": [
          {
            "iam_bearer_token": []
          }
        ],
        "x-sdk-operations": {
          "request-examples": {
            "curl": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "curl -X POST --location --header \"Authorization: Bearer ${iam_token}\" \\\n",
                      "  --header \"Accept: application/json\" \\\n",
                      "  --header \"Content-Type: application/json\" \\\n",
                      "  --data '{ \"force\": true }' \\\n",
                      "  \"https://api.us-south.devops.cloud.ibm.com/pipeline/v2/tekton_pipelines/94619026-912b-4d92-8f51-6c74f0692d90/pipeline_runs/94619026-912b-4d92-8f51-6c74f0692d90/cancel\""
                    ]
                  }
                ]
              }
            ],
            "go": [
              {
                "name": "Example request",
                "example": [
                  {
[...]
